// VARS

var cells = [[""]], cells_w = 1, cells_h = 1, sel_x = null, sel_y = null;

var $nastrojova_lista, $editacni_radek, $table_container, $table, $bunky, $sloupce, $lista_horni, $lista_horni_container, $lista_bocni, $fonty;

// UTILITY

function getColName(col_num)
{
	if(col_num < 26)
		return String.fromCharCode(65+col_num);
	else
		return String.fromCharCode(64+Math.floor(col_num/26)) + String.fromCharCode(65 + col_num % 26);
}

function getColNum(col_name)
{
	if(col_name.length == 1)
		return col_name.charCodeAt(0) - 65;
	else
		return ((col_name.charCodeAt(0) - 64) * 26) + (col_name.charCodeAt(0) - 65);
}

function getRowName(row_num)
{
	return ""+(row_num+1);
}

function getRowNum(row_name)
{
	return (+row_name)-1;
}

function addRowBefore(index)
{
	cells.splice(index, 0, new Array(cells_w).fill(""));
	cells_h++;
	$lista_bocni.append($("<div>").text(getRowName(cells_h - 1)));
	var $tr = $("<tr>");
	for(var i = 0; i < cells_w; i++)
	{
		$tr.append($("<td><div><div></td>"));
	}
	$tr.insertBefore($bunky.find("tr:nth-child("+(index+1)+")"));
}

function removeRow(index)
{
	cells.splice(index, 1);
	cells_h--;
	$lista_bocni.find(":last-child").remove();
	$bunky.find("tr:nth-child("+(index+1)+")").remove();
}

function removeCol(index)
{
	for(var i in cells)
	{
		cells[i].splice(index, 1)
	}
	cells_w--;
	$lista_horni.find(":last-child").remove();
	$bunky.find("td:nth-child("+(index+1)+")").remove();
}

function addColBefore(index)
{
	for(var i in cells)
	{
		cells[i].splice(index, 0, "")
	}

	cells_w++;
	$lista_horni.append($("<div>").text(getColName(cells_w - 1)));

	$sloupce.append("<col>");

	$bunky.find("tr").each(function(){
		$("<td><div><div></td>").insertBefore($(this).find("td:nth-child("+(index+1)+")"))
	});

	$table.width(cells_w * 80);
	$lista_horni.width(cells_w * 80);
}

function evalCell(x, y)
{
	var txt = cells[y][x];
	if(txt[0] == "=")
	{
		var code = txt.substr(1);
		var vars = {};
		var result = "NaN";

		for (var x=0; x < cells_w; x++) for (var y=0; y < cells_h; y++)
		{
			var cell_name = getColName(x) + getRowName(y);
			if(code.indexOf(cell_name) > -1)
			{
				var curvar = evalCell(x, y);
				var parsed = parseFloat(curvar, 10);
				vars[cell_name] = isNaN(parsed) ? curvar : parsed;
			}
		}
		console.log(vars);
		try
		{
			with(vars)
			{
				eval("result = "+code);
			}
		}
		catch(e) { console.log(e); }
		if(typeof result == "string" || typeof result == "number")
			txt = result;
		else
			txt = "NaN";
	}
	return txt;
}

function updateCell(x, y)
{
	txt = evalCell(x, y);
	$bunky.find("tr:nth-child("+(y+1)+") td:nth-child("+(x+1)+") div").text(txt);
}


// APP

function init()
{
	$nastrojova_lista = $("#nastrojova-lista");
	$editacni_radek = $("#editacni-radek");
	$table_container = $("#table-container");
	$table = $("#table");
	$bunky = $("#bunky");
	$sloupce = $("#sloupce");
	$lista_horni = $("#lista-horni");
	$lista_horni_container = $("#lista-horni-container");
	$lista_bocni = $("#lista-bocni");
	$fonty = $("#fonty");


	// vyrobíme buňky

	for(var i = 0; i < 99; i++)
		addRowBefore(0);

	for(var i = 0; i < 25; i++)
		addColBefore(0);

	// scrolling
	$table_container.scroll(function(){
		$lista_bocni.scrollTop(($table_container.scrollTop()));
		$lista_horni.css("margin-left", "-"+($table_container.scrollLeft())+"px");
	});

	// editace
	$table.on("click", "td", function()
	{
		$this = $(this);
		$(".selected").removeClass("selected");
		$this.addClass("selected");
		sel_x = $this.index();
		sel_y = $this.parent().index();
		$editacni_radek.val(cells[sel_y][sel_x]).focus();
		$fonty.val(($this.attr("class").match(/font-([a-z]+)/) || [0,"arial"])[1]);
	});

	$editacni_radek.on("input", function(){
		if(sel_x != null)
		{
			var txt = cells[sel_y][sel_x] = $editacni_radek.val();
			for (var x=0; x < cells_w; x++) for (var y=0; y < cells_h; y++)
				if(cells[y][x] && cells[y][x][0] == "=") updateCell(x, y);
			updateCell(sel_x, sel_y);

		}
	});

	// nastrojova lista
	$nastrojova_lista.on("click", "button", function()
	{
		switch($(this).attr("id"))
		{
			case "B":
				$(".selected").toggleClass("B");
			break;
			case "I":
				$(".selected").toggleClass("I");
			break;
			case "U":
				$(".selected").toggleClass("U");
			break;


			case "plus-font":
				var $selected = $(".selected");
				$selected.css("font-size", +($selected.css("font-size").replace("px","")) + 2);
			break;
			case "minus-font":
				var $selected = $(".selected");
				$selected.css("font-size", +($selected.css("font-size").replace("px","")) - 2);
			break;

			case "odebrat-formatovani":
				var $selected = $(".selected");
				$selected.attr("style", "").attr("class", "selected");
			break;


			case "plus-radek":
				addRowBefore(sel_y);
				sel_y++;
			break;
			case "plus-sloupec":
				addColBefore(sel_x);
				sel_x++;
			break;
			case "minus-radek":
				removeRow(sel_y);
				sel_x = null;
				sel_y = null;
			break;
			case "minus-sloupec":
				removeCol(sel_x);
				sel_x = null;
				sel_y = null;
			break;
		}
	});

	$fonty.on("change", function(){
		var font = $fonty.val();
		var $selected = $(".selected");
		$selected.attr("class", $selected.attr("class").replace(/font-[a-z]+/g, "") + " font-" + font);
	});
}

$(init);